// mainfrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "except.h"
#include "mainfrm.h"

#include "sigcpp.h"  // combined setjmp.h & signal.h, modified for use with C++ 
#include <float.h>
#include <eh.h>		// _set_se_translator

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif



/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_COMMAND(ID_SX_CRUNTIME_RAISE, OnSxRaise)
	ON_COMMAND(ID_SX_MFC_AFXTHROWXXXEXCEPTION, OnSxAfxthrowxxxexception)
	ON_COMMAND(ID_SX_MFC_TRYCATCHTHROW, OnSxTrycatchthrow)
	ON_COMMAND(ID_HX_CRUNTIME_SIGNAL, OnHxSetjmplongjmp)
	ON_COMMAND(ID_UX_FPDIVBYZERO, OnUxFpdivbyzero)
	ON_COMMAND(ID_UX_INTDIVBYZERO,OnUxIntdivbyzero)
	ON_COMMAND(ID_HX_CPP_TRYCATCHFPDIVBYZERO, OnHxCppTrycatchfpdivbyzero)
	ON_COMMAND(ID_HX_CPP_TRYCATCHINTDIVBYZERO, OnHxCppTrycatchintdivbyzero)
	ON_COMMAND(ID_HX_SEH_TRYEXCEPTFPDIVBYZERO, OnHxSehTryexceptfpdivbyzero)
	ON_COMMAND(ID_HX_SEH_TRYEXCEPTINTDIVBYZERO, OnHxSehTryexceptintdivbyzero)
	ON_COMMAND(ID_SX_CPP_RAISE, OnSxCppRaise)
	ON_COMMAND(ID_SX_CPP_RAISEEXCEPTION, OnSxCppRaiseexception)
	ON_COMMAND(ID_SX_CPP_TRYCATCHAFXTHROW, OnSxCppTrycatchafxthrow)
	ON_COMMAND(ID_SX_CPP_TRYCATCHTHROW, OnSxCppTrycatchthrow)
	ON_COMMAND(ID_SX_SEH_AFXTHROWFILEEXCEPTION, OnSxSehAfxthrowfileexception)
	ON_COMMAND(ID_SX_SEH_RAISE, OnSxSehRaise)
	ON_COMMAND(ID_SX_SEH_RAISEEXCEPTION, OnSxSehRaiseexception)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

///////////////////////////////////////////////////////////////////////////////////////
//
//  To use C++ Exception handling (try, catch) for structured exceptions, we must
//  install a function to redirect them to C++ catch handlers. The following 
//  CSEHexception class and MapStructuredExceptionsIntoCPPExceptions function are
//  needed to implement this feature.
//

class CSEHexception
	{
	private:
    	UINT m_uCode;
	public:
    	CSEHexception() {}
    	CSEHexception( UINT uCode ) : m_uCode( uCode ) {}
    	~CSEHexception() {}
    	unsigned int GetNumber() { return m_uCode; }
	};

void MapStructuredExceptionsIntoCPPExceptions(UINT uCode, _EXCEPTION_POINTERS* /* pep */)
	{
	throw CSEHexception (uCode);
	}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
	{
	//	To trap floating point exceptions under NT, use _controlfp().
	//	Reset the status bits in the exception handler with _clearfp().
	//
	int cw = ::_controlfp(0,0);
	cw &= ~(_EM_ZERODIVIDE | _EM_INVALID | _EM_DENORMAL | 
	   	    _EM_OVERFLOW | _EM_UNDERFLOW | _EM_INEXACT);
	::_controlfp(cw, _MCW_EM);		
	
	//  To use C++ Exception handling (try, catch) for structured exceptions,
	//  install a function to redirect them to C++ catch handlers.
	//
	//
	_set_se_translator (MapStructuredExceptionsIntoCPPExceptions);
	}

CMainFrame::~CMainFrame()
{
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG




/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers

	
	
////////////////////////////////////////////////////////////////////////////////////////////
//
//    Exception handling using signal,setjmp,longjmp (and raise)
//
////////////////////////////////////////////////////////////////////////////////////////////
static jmp_buf setjmplongjmpBuffer;	// buffer for registers that longjmp will restore

extern "C" void SetjmpLongjmpSIGFPEHandler (int /*sig*/, int /*num*/)
	{
	_clearfp();
	longjmp (setjmplongjmpBuffer, -1);
	}
	
void CMainFrame::OnHxSetjmplongjmp()
	{
	//  step 1: install the exception handler for fp div by zero
	//    
	if ( signal(SIGFPE, (void (__cdecl *)(int, ...))::SetjmpLongjmpSIGFPEHandler) == SIG_ERR ) return;	                                   
	
	//  step 2: do a "try", "catch"
	//                    
	int iRet = ::setjmp (setjmplongjmpBuffer);	// here's where longjmp jumps to
	if (iRet == 0)
		{
		double x = 1.0;	//  "try"...
		x = x / 0.0f ;                                       
		::AfxMessageBox("Should never get here...exception not caught");
		}
	else  				//  "catch"...
		{				
		::AfxMessageBox("fp divide by zero trapped with signal,setjmp,longjmp");
		}
	}

void CMainFrame::OnSxRaise()
	{
	//  step 1: install the exception handler for fp div by zero
	//    
	if ( signal(SIGFPE, (void (__cdecl *)(int, ...))::SetjmpLongjmpSIGFPEHandler) == SIG_ERR ) return;	                                   
	
	//  step 2: do a "try", "catch"
	//                    
	int iRet = ::setjmp (setjmplongjmpBuffer);	// here's where longjmp jumps to
	if (iRet == 0)
		{
		raise(SIGFPE);
		::AfxMessageBox("Should never get here...exception not caught");
		}
	else  				//  "catch"...
		{				
		::AfxMessageBox("raise trapped with signal,setjmp,longjmp");
		}
	}

	
	  
///////////////////////////////////////////////////////////////////////////////////////////
//
//  MFC exception handling using TRY, CATCH macros and AfxThrowXxxException.
//
////////////////////////////////////////////////////////////////////////////////////////////
void CMainFrame::OnSxAfxthrowxxxexception()
	{
	TRY
		{
		CFile f("ohbaby", CFile::modeRead); // throws exception if "ohbaby" doesn't exist
		::AfxMessageBox("Should never get here...CFile exception not caught");
		}
	CATCH (CFileException, e)
		{
		CString sReason;
		switch (e->m_cause)
			{
			case CFileException::fileNotFound	: sReason = "file not found";	break;
			case CFileException::badPath		: sReason = "bad path";			break;
			default								: sReason = "unable to open file"; break;
			}
		CString s = "CFileException (" + sReason + ") trapped with TRY, CATCH";
		::AfxMessageBox(s);
		}
	END_CATCH
	}

void MyBadFunction(){AfxThrowUserException();}
	
void CMainFrame::OnSxTrycatchthrow()
	{
	TRY
		{
		MyBadFunction(); // throws CUserException
		::AfxMessageBox("Should never get here...exception not caught");
		}
	CATCH (CUserException, e)
		{
		::AfxMessageBox("AfxThrowUserException trapped with TRY, CATCH");
		}
	END_CATCH
	}

	  
///////////////////////////////////////////////////////////////////////////////////////////
//
//    Win32 Structured Exception Handling (SEH) using C/C++ __try, __except
//
////////////////////////////////////////////////////////////////////////////////////////////
void CMainFrame::OnHxSehTryexceptfpdivbyzero()
	{
	__try	
		{
		double x = 1.0;
		x = x / 0.0f ;                                       
		::AfxMessageBox("Should never get here...exception not caught");
		}
	__except (GetExceptionCode() ==  EXCEPTION_FLT_DIVIDE_BY_ZERO ? 
									 EXCEPTION_EXECUTE_HANDLER : EXCEPTION_CONTINUE_SEARCH)  				//  "catch"...
		{
		_clearfp();				
		::AfxMessageBox("fp divide by zero trapped with __try, __except");
		}
	}

void CMainFrame::OnHxSehTryexceptintdivbyzero()
	{
	__try	
		{
		int x = 1;
		x = x / 0;                                       
		::AfxMessageBox("Should never get here...exception not caught");
		}
	__except (GetExceptionCode() ==  EXCEPTION_INT_DIVIDE_BY_ZERO ? 
									 EXCEPTION_EXECUTE_HANDLER : EXCEPTION_CONTINUE_SEARCH)  				//  "catch"...
		{				
		::AfxMessageBox("integer divide by zero trapped with __try, __except");
		}	
	}

void CMainFrame::OnSxSehRaiseexception()
	{
	#define EXCEPTION_MYEXCEPTION 0xE0000001

	__try	
		{
		RaiseException(EXCEPTION_MYEXCEPTION, 0,0,0);
		::AfxMessageBox("Should never get here...exception not caught");
		}
	__except (GetExceptionCode() ==  EXCEPTION_MYEXCEPTION ? 
									 EXCEPTION_EXECUTE_HANDLER : EXCEPTION_CONTINUE_SEARCH)  				//  "catch"...
		{				
		::AfxMessageBox("RaiseException trapped with __try, __except");
		}
	}

void CMainFrame::OnSxSehAfxthrowfileexception()
	{
	}

void CMainFrame::OnSxSehRaise()
	{
	}
	  
///////////////////////////////////////////////////////////////////////////////////////////
//
//    C++ Exception Handling (try catch throw).
//  
////////////////////////////////////////////////////////////////////////////////////////////


void CMainFrame::OnHxCppTrycatchfpdivbyzero()
	{
	try	
		{
		double x = 1.0;
		x = x / 0.0f ;                                    
		::AfxMessageBox("Should never get here...exception not caught");
		}
	catch (CSEHexception e)
		{
		if (e.GetNumber() == EXCEPTION_FLT_DIVIDE_BY_ZERO)
			{
			_clearfp();				
			::AfxMessageBox("fp DivByZero trapped with try, catch");
			}
		}
	}

void CMainFrame::OnHxCppTrycatchintdivbyzero()
	{
	try	
		{
		int x = 1;
		x = x / 0;                                       
		::AfxMessageBox("Should never get here...exception not caught");
		}
	catch (CSEHexception e)
		{				
		if (e.GetNumber() == EXCEPTION_INT_DIVIDE_BY_ZERO)
			{
			::AfxMessageBox("integer divide by zero trapped with try, catch");
			}
		}
	}


void CMainFrame::OnSxCppTrycatchthrow()
	{
	try
		{
		throw "uh oh";
		::AfxMessageBox("Should never get here...exception not caught");
		}
	catch (char *)
		{
		::AfxMessageBox("throw char* trapped with try, catch");
		}
	}

void CMainFrame::OnSxCppTrycatchafxthrow()
	{
	try
		{
		CFile f("ohbaby", CFile::modeRead); // throws exception if "ohbaby" doesn't exist
		::AfxMessageBox("Should never get here...CFile exception not caught");
		}
	catch (...)
		{
		::AfxMessageBox("AfxThrowFileException trapped with try, catch(...)");
		}
	}

void CMainFrame::OnSxCppRaise()
	{
	try
		{
		raise(SIGFPE);
		::AfxMessageBox("Should never get here...exception not caught");
		}
	catch (...)
		{
		::AfxMessageBox("raise(SIGFPE) trapped with try, catch(...)");
		}
	}

void CMainFrame::OnSxCppRaiseexception()
	{
	#define EXCEPTION_MYEXCEPTION 0xE0000001
	CString str("This string will get de-allocated!");

	try	
		{
		RaiseException(EXCEPTION_MYEXCEPTION, 0,0,0);
		::AfxMessageBox("Should never get here...exception not caught");
		}
	catch (CSEHexception e)
		{
		if (e.GetNumber() == EXCEPTION_MYEXCEPTION)
			{			
			::AfxMessageBox("RaiseException trapped with try, catch");
			}
		}
	}

///////////////////////////////////////////////////////////////////////////////////////////
//
//    Demonstrate NT's default exception handling.
//    Note that Dr Watson logs error and aborts app.
//
////////////////////////////////////////////////////////////////////////////////////////////
void CMainFrame::OnUxFpdivbyzero()
	{
	//	Generate an fp exception & let NT's default handler deal with it.
	//
	//	To trap floating point exceptions under NT, use _controlfp().
	//
	double x = 1.;
	x /= 0.;
	::AfxMessageBox("fp divide by zero exception not caught");	
	}

void CMainFrame::OnUxIntdivbyzero()
	{
	//	Generate an int div by zero exception & let default handler deal with it.
	//
	int x = 1;
	x /= 0;
	::AfxMessageBox("integer divide by zero exception not caught");	
	}


